/*
 * Copyright 2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.codegen.ant;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Arrays;
import java.util.ListIterator;

import org.seasar.framework.util.StringUtil;

public class CodeGenMain {
    private File csvFile;

    private File destinationDir;

    private String diconDir;
    
    private String diconPath;

    private String packageName="";

    private String templateDir="fm/java/";

    public void execute() {
        File dir ;
        if(StringUtil.isEmpty(diconPath)) {
            dir = new File(diconDir);
        } else {
            dir = new File(diconDir+"/" + diconPath);
        }
        if (!dir.exists()) {
            throw new RuntimeException("directory does not exist [" + dir + "]");
        }
        String[] diconFileNames = dir.list(new FilenameFilter() {
            public boolean accept(File dir, String name) {
                return (name.endsWith(".dicon") && (!("ERWinCSV.dicon"
                        .equals(name))));
            }
        });

        ListIterator iter = Arrays.asList(diconFileNames).listIterator();
        while (iter.hasNext()) {
            String diconPath = this.diconPath + (String) iter.next();

            EachGen eachGen = new EachGen();
            eachGen.setDiconPath(diconPath);
            eachGen.setCsvFile(this.csvFile);
            eachGen.setDestinationDir(this.destinationDir);
            eachGen.setPackageName(this.packageName);
            eachGen.setTemplateDir(this.templateDir);

            eachGen.generate();
        }
    }

    public void setDestinationDir(File dir) {
        this.destinationDir = dir;
    }

    public void setCsvFile(File csv) {
        this.csvFile = csv;
    }

    public void setDiconDir(String diconDir) {
        this.diconDir = diconDir;
    }

    public void setPackageName(String packageName) {
        this.packageName = packageName;
    }

    public void setTemplateDir(String templateDir) {
        this.templateDir = templateDir;
    }

    public void setDiconPath(String diconPath) {
        this.diconPath = diconPath;
    }
}
