/*
 * Copyright 2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.codegen.element;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class Table {
    private String tableName;

    private String tableNameForDto;

    private List primaryKey = new ArrayList();

    private List tableField = new ArrayList();

    private Map fieldMap = new HashMap();

    private List parentTable = new ArrayList();

    private List childTable = new ArrayList();

    private List validator = new ArrayList();

    public List getFieldImportDef() {
        List importList = new ArrayList();
        Set importSet = new HashSet();
        Iterator ite = tableField.iterator();
        while (ite.hasNext()) {
            Field field = (Field) ite.next();
            importSet.addAll(field.getDataType().getLangDataType()
                    .getImportNames());
        }
        importList.addAll(importSet);
        return importList;
    }

    public List getChildTable() {
        return childTable;
    }

    public void setChildTable(List childTable) {
        this.childTable = childTable;
    }

    public void addChildTable(LinkTable oneChildTable) {
        childTable.add(oneChildTable);
    }

    public List getParentTable() {
        return parentTable;
    }

    public void setParentTable(List linkTable) {
        this.parentTable = linkTable;
    }

    public void addLinkTable(LinkTable oneLinkTable) {
        parentTable.add(oneLinkTable);
    }

    public List getPrimaryKey() {
        return primaryKey;
    }

    public void setPrimaryKey(List primaryKey) {
        this.primaryKey = primaryKey;
    }

    public void addPrimaryKey(PrimaryKey onePrimaryKey) {
        primaryKey.add(onePrimaryKey);
    }

    public List getTableField() {
        return tableField;
    }

    public void setTableField(List tableField) {
        this.tableField = tableField;
    }

    public void addTableField(Field oneTableField) {
        tableField.add(oneTableField);
        fieldMap.put(oneTableField.getFieldName(), oneTableField);
    }

    public Field getTableField(String firldName) {
        return (Field) fieldMap.get(firldName);
    }

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    public List getValidator() {
        return validator;
    }

    public void setValidator(List validator) {
        this.validator = validator;
    }

    public void addValidator(TableValidator oneTableValidator) {
        validator.add(oneTableValidator);
    }

    public String getTableNameForDto() {
        if (tableNameForDto == null){
            return tableName;
        }
        return tableNameForDto;
    }

    public void setTableNameForDto(String tableNameForDto) {
        this.tableNameForDto = tableNameForDto;
    }

    public String toString() {
        StringBuffer buffer = new StringBuffer("[Table");
        buffer.append("\n  /tableName=").append(tableName);
        buffer.append("\n  /primaryKey=").append(primaryKey);
        buffer.append("\n  /tableField=").append(tableField);
        buffer.append("\n  /parentTable=").append(parentTable);
        buffer.append("\n  /childTable=").append(childTable);
        buffer.append("\n  /validator=").append(validator);
        buffer.append("\n\n");
        return buffer.toString();
    }

}
